import { uploadFiles } from "@/lib/uploadthing"
import { IProfile } from "./../types/index"

export const updateProfile = async ({
    profile,
    userId,
}: {
    profile: IProfile
    userId: string
}) => {
    if (!profile) return

    try {
        let bannerfileprops: { fileUrl: string; fileKey: string } = { fileUrl: '', fileKey: '' }
        let imagefileprops: { fileUrl: string; fileKey: string } = { fileUrl: '', fileKey: '' }

        if (profile.banner.file) {
            [bannerfileprops] = await uploadFiles({ files: [profile.banner.file], endpoint: 'mediaUploader' })
        }

        if (profile.image.file) {
            [imagefileprops] = await uploadFiles({ files: [profile.image.file], endpoint: 'imageUploader' })
        }

        const data = await fetch(`/api/users/${userId}`, {
            method: 'PUT',
            body: JSON.stringify({
                userId,
                name: profile.name,
                bio: profile.bio,
                location: profile.location,
                website: profile.website,
                banner: bannerfileprops.fileUrl !== "" ? bannerfileprops.fileUrl : profile?.banner?.url,
                image: imagefileprops.fileUrl !== "" ? imagefileprops.fileUrl : profile?.image?.url,
            })
        }).then((result) => result.json())

        return data
    } catch (error: any) {
        return error.Message
    }
}